<?

// Tell the system we are in processor mode
$processor = 1;

// Set some initital variables
$processorVersion = "3.66";
$flashWriteCount = 0;
$fs = 0;

// Includes
if (!@include "../conf/conf.php") {
	echo "Aanval BPU Fatal Error: This console is not properly configured. Please re-install.\n\n";
	echo "FILE: ../conf/conf.php - Missing or not found.\n\n";
	exit;
}
if (!@include "./processor.php") {
	echo "Aanval BPU Fatal Error: This console is not properly configured. Please re-install.\n\n";
	echo "FILE: ./processor.php - Missing or not found.\n\n";
	exit;
}

// Exit if in setup or upgrade mode
if (file_exists("../installation/setup.php")) {
	echo "Aanval In Setup / Upgrade Mode - Exiting.\n\n";
	exit;
}

// Load appropriate modules
recursiveModuleLoad(0);

// Simulate login to console
$login = new mySession("processor");

// Set Script TIMEOUT Value
set_time_limit(2000);

// Variable Initilization
$ops = new myOps();
$ops->loadOps();

// Away we go!
$start = date("U");

procWrite("A", "RESET");

procWrite("A", "----------------------------------------------------");
procWrite("A", ":: BPU: Background Processing Unit A v$processorVersion");
procWrite("A", ":: IDS: " . versionText());
procWrite("A", ":: Last processing finished " . statusProcessorLastRunDiff("A") . " seconds ago.");
procWrite("A", "----------------------------------------------------\n");

// Hold Check
if (file_exists("$root_path/tmp/holdA.tmp")) {
	procwrite("A", ":: ON HOLD -> Exiting");
	exit;
}

// Spion Processing Function
#idsSpion();

// Snort Processing Function
idsSnort();

// Syslog Processing Function
idsSyslog();

$objStatus = new myStatus();
$objStatus->loadStatus();
$objStatus->setStatusVar("processorA_lastRun", date("U"));
$objStatus->totalProcessorRunIncrement("A");
$objStatus->saveStatus();

$end = date("U");
$seconds = $end - $start;

// Write flash poll files
writeFlashPoll($flashWriteCount);

// Defaults
if (!$opsSetCount) $opsSetCount = 0;
if (!$opsGetCount) $opsGetCount = 0;

// Include checks
foreach (get_included_files() as $file) {
	$size = $size + filesize($file);
	$cnt++;
}
$fs = humanReadablefilesize($size) . " in $cnt";

// Footer
procWrite("A", "----------------------------------------------------");
procwrite("A", ":: Set ($opsSetCount)");
procwrite("A", ":: Get ($opsGetCount)");
procWrite("A", ":: Mem ($fs)");
procWrite("A", ":: Complete - $seconds");
procWrite("A", "----------------------------------------------------");

exit;

?>
