<?

// Tell the system we are in processor mode      :
$processor = 1;

// Set some initital variables
$processorVersion = "3.22";

// Includes
if (!@include "../conf/conf.php") {
	echo "Aanval BPU Fatal Error: This console is not properly configured. Please re-install.\n\n";
	echo "FILE: ../conf/conf.php - Missing or not found.\n\n";
	exit;
}
if (!@include "./processor.php") {
	echo "Aanval BPU Fatal Error: This console is not properly configured. Please re-install.\n\n";
	echo "FILE: ./processor.php - Missing or not found.\n\n";
	exit;
}

// Exit if in setup or upgrade mode
if (file_exists("../installation/setup.php")) {
	echo "Aanval In Setup / Upgrade Mode - Exiting.\n\n";
	exit;
}

// Load appropriate modules
recursiveModuleLoad(0);

// Simulate login to console
$login = new mySession("processor");

// Set Script TIMEOUT Value
set_time_limit(2000);

// Variable Initilization
$ops = new myOps();
$ops->loadOps();

// Away we go!
$start = date("U");

procWrite("B", "RESET");

procWrite("B", "----------------------------------------------------");
procWrite("B", ":: BPU: Background Processing Unit B v$processorVersion");
procWrite("B", ":: IDS: " . versionText());
procWrite("B", ":: Last processing finished " . statusProcessorLastRunDiff("B") . " seconds ago.");
procWrite("B", "----------------------------------------------------\n");

// Hold Check
if (file_exists("$root_path/tmp/holdB.tmp")) {
	procwrite("B", ":: ON HOLD -> Exiting");
	exit;
}

// Version Checking
remoteVersionCheck();

// Bulletin Checking
remoteBulletinCheck();

// Permissions Checking
permissionsCheck();

// Community Communication
communityBufferProcess();

// CUT idsMain DOWN TO SIZE
pruneIdsMain();

// CUT idsLogs DOWN TO SIZE
pruneIdsLogs();

// Delete Ignored Events
deleteIgnoredEvents();

// Archive Processor
archiveTableProcessor();

// IP to Hostname Lookups
hostnameLookup();

// OAD
$oadProcess = oadProcess();

$objStatus = new myStatus();
$objStatus->loadStatus();
$objStatus->setStatusVar("processorB_lastRun", date("U"));
if ($oadProcess == 1) $objStatus->setStatusVar("oad_lastUpload", date("U"));
if ($oadProcess == 1) $objStatus->totalOadUploadIncrement();
$objStatus->totalProcessorRunIncrement("B");
$objStatus->saveStatus();

// Action Processor
actionProcessor();

// Scanner
scanProcessor();

// Signature System
sigProcessor();

// AI (Artificial Intelligence)
aiProcessor();

// Daily Reports
processDailyReports();

// Report Schedule
processReportSchedule();

// Mail Processor
processMail();

// Auto Snort Trimming
autoSnortTrimmer();

$end = date("U");
$seconds = $end - $start;

// Defaults
if (!$opsSetCount) $opsSetCount = 0;
if (!$opsGetCount) $opsGetCount = 0;

// Include checks
foreach (get_included_files() as $file) {
	$size = $size + filesize($file);
	$cnt++;
}
$fs = humanReadablefilesize($size) . " in $cnt";

// Footer
procWrite("B", "----------------------------------------------------");
procwrite("B", ":: Set ($opsSetCount)");
procwrite("B", ":: Get ($opsGetCount)");
procWrite("A", ":: Mem ($fs)");
procWrite("B", ":: Complete - $seconds");
procWrite("B", "----------------------------------------------------");

exit;

?>
