<?

// Tell the system we are in processor mode      :
$processor = 1;

// Set some initital variables
$processorVersion = "2.73";

// Includes
if (!@include "../conf/conf.php") {
	echo "Aanval BPU Fatal Error: This console is not properly configured. Please re-install.\n\n";
	echo "FILE: ../conf/conf.php - Missing or not found.\n\n";
	exit;
}
if (!@include "./processor.php") {
	echo "Aanval BPU Fatal Error: This console is not properly configured. Please re-install.\n\n";
	echo "FILE: ./processor.php - Missing or not found.\n\n";
	exit;
}

// Exit if in setup or upgrade mode
if (file_exists("../installation/setup.php")) {
	echo "Aanval In Setup / Upgrade Mode - Exiting.\n\n";
	exit;
}

// Load appropriate modules
recursiveModuleLoad(0);

// Simulate login to console
$login = new mySession("processor");

// Set Script TIMEOUT Value
set_time_limit(2000);

// Variable Initilization
$ops = new myOps();
$ops->loadOps();

// Away we go!
$start = date("U");

procWrite("C", "RESET");

procWrite("C", "----------------------------------------------------");
procWrite("C", ":: BPU: Background Processing Unit C v$processorVersion");
procWrite("C", ":: IDS: " . versionText());
procWrite("C", ":: Last processing finished " . statusProcessorLastRunDiff("C") . " seconds ago.");
procWrite("C", "----------------------------------------------------\n");

// Hold Check
if (file_exists("$root_path/tmp/holdC.tmp")) {
	procwrite("C", ":: ON HOLD -> Exiting");
	exit;
}

// Index System
indexer();

$objStatus = new myStatus();
$objStatus->loadStatus();
$objStatus->setStatusVar("processorC_lastRun", date("U"));
$objStatus->totalProcessorRunIncrement("C");
$objStatus->saveStatus();

$end = date("U");
$seconds = $end - $start;

// Defaults
if (!$opsSetCount) $opsSetCount = 0;
if (!$opsGetCount) $opsGetCount = 0;

// Include checks
foreach (get_included_files() as $file) {
	$size = $size + filesize($file);
	$cnt++;
}
$fs = humanReadablefilesize($size) . " in $cnt";

// Footer
procWrite("C", "----------------------------------------------------");
procwrite("C", ":: Set ($opsSetCount)");
procwrite("C", ":: Get ($opsGetCount)");
procWrite("C", ":: Mem ($fs)");
procWrite("C", ":: Complete - $seconds");
procWrite("C", "----------------------------------------------------");

exit;

?>