<?

class indexer {

	function processIndexes() {
		global $ops;

		// Retrieve and set max indexing rows per run variable
	    $numRow = $ops->getOpsVar("site_processorIndexRun");
	    if (!$numRow) $numRow = 500;

	    // Display
	    procWrite("C", " . Max Indexes Per Run: $numRow");
	    
	    // Retrieve active data table for indexing
	    $table = $ops->getOpsVar("site_activeDataTable");
	
	    // Instantiate new status object
		$objStatus = new myStatus();
		
		// Load status
		$objStatus->loadStatus();
	
		// Retrieve table id of last indexed record
		$lastIndex = $objStatus->getStatusVar("processor_lastIndex");
	    if (!$lastIndex) $lastIndex = 0;

	    // Display
	    procWrite("C", " . Last Indexed Event ID: $lastIndex");
		
	    // Set Index intensity variable
	    $indexIntensity = $ops->getOpsVar("indexIntensity");
	    
	    // Instantiate new database object
	    $idsDB = new idsDB();
	    
#	    $idsQueryA = $idsDB->query("LOCK TABLES idsReverseIndex, idsReverseIndexSip, idsReverseIndexSport, idsReverseIndexDport, idsReverseIndexDip, idsReverseIndexSignature, idsReverseIndexLevel, idsReverseIndexModule, idsReverseIndexSensor, idsReverseIndexAck, idsReverseIndexWin, idsReverseIndexTtl, idsReverseIndexSeq, idsReverseIndexCategory, idsReverseIndexTime, idsReverseIndexProto, idsReverseIndexLen WRITE");

	    // Query for all table row data > than last indexed row
	    $idsQueryA = $idsDB->query("select id, level, module, sensorid, ename, enameid, etypename, etypeid, sip, dip, sport, dport, payload, hdr_seq, hdr_ack, ip_ttl, ip_len, hdr_win, proto, epoch from $table where id > $lastIndex limit $numRow");
	    while (list($id, $level, $module, $sensorid, $ename, $enameid, $etypename, $etypeid, $sip, $dip, $sport, $dport, $data_payload, $hdr_seq, $hdr_ack, $ip_ttl, $ip_len, $hdr_win, $proto, $epoch) = mysql_fetch_row($idsQueryA)) {
	
	    	// Increment counter
	    	$cnt++;
	    	
			// Index level 3 (Highest)
	        if ($indexIntensity == 3) {
	        	
	        	// Payload processing for indexes
	            if ($dport == 80 || $sport == 80 || $dport == 25 || $sport == 25) {

	            	// Check for module type
	    			if ($module == 1) {
	    				
	    				// Decode snort module payloads
		                $payload = strip_tags(packet_payload($data_payload, 3, 1));
	    			} else {
	    				
	    				// Set syslog module payloads
	    				$payload = $data_payload;
	    			}
	            } else {
	            	
	            	// Check for module type
	            	if ($module == 2) {
	            		
	            		// Set syslog module payloads
	            		$payload = $data_payload;
	            	}
	            }

	            // Retrieve words from payload
				$array = split("[^[:alpha:]]+", $payload);

	            // Parse out duplicates from array
	            $array = array_unique($array);
	
	            // Write words to index
				$this->writeWordIndex($id, $array);         
	            
	            // Clear / cleanup variables for memory preservation
	            unset($array);
	            unset($payload);
	
	            $a_ip_len[] = $ip_len;
	            $a_hdr_win[] = $hdr_win;
	            $a_ip_ttl[] = $ip_ttl;
	            $a_hdr_seq[] = $hdr_seq;
	            $a_hdr_ack[] = $hdr_ack;
	            
	        }
	        if ($indexIntensity == 2 || $indexIntensity == 3) {
	      	
	        	// Retrieve words from signature category and signature names
	        	$array1 = split("[^[:alpha:]]+", "$etypename $ename");
	        	$array2 = "$etypename $ename";
				$array2 = explode(" ", $array2);
	        	
	            // Parse out duplicates from array
	            $array1 = array_unique($array1);
	            $array2 = array_unique($array2);
	
	            // Write words to index
				$this->writeWordIndex($id, $array1);         
				$this->writeWordIndex($id, $array2);         
            
	            // Clean up by clearing previous arrays
	            unset($array1, $array2);
	        }
	
	        $last = $id;
	        
            if (strstr($cnt, "00")) {
                procWrite("C", " . $cnt Rows Indexed");
            }
                    
            $a_id[] = $id;
            $a_sip[] = $sip;
            $a_dip[] = $dip;
            $a_sport[] = $sport;
            $a_dport[] = $dport;
            $a_epoch[] = $epoch;
            $a_proto[] = $proto;
            $a_sensorid[] = $sensorid;
            $a_etypeid[] = $etypeid;
            $a_enameid[] = $enameid;
            $a_etypename[] = $etypename;
            $a_ename[] = $ename;
            $a_level[] = $level;
            $a_module[] = $module;
	    }

	    // If new indexes are to be created, otherwise skip this section
	    if ($cnt) {
	    
		    if ($indexIntensity == 3) {
	            // Write the following fields to indexes
	            $this->writeAdvancedIndex($a_id, $a_ip_len, $a_hdr_win, $a_ip_ttl, $a_hdr_seq, $a_hdr_ack);
		    }
		    
	        // Write the following fields to indexes
	        $this->writeStandardIndex($a_id, $a_sip, $a_dip, $a_sport, $a_dport, $a_epoch, $a_proto, $a_sensorid, $a_etypeid, $a_enameid, $a_level, $a_module, $a_ename, $a_etypename);
	        
		    // Close database handle
		    $idsDB->close();
	    }
	
	    // Only update last event processed if processing took place
	    if ($last) {
	        $objStatus->setStatusVar("processor_lastIndex", $last);
		    $objStatus->saveStatus();
	    } else {
	    	
	    	// If no indexing took place, then we will want to run the sanitizer
	    	$this->sanitizeIndexes();
	    	
	    }
	
	    // Check if reprocess of indexes was manually forced via console
	    if ($ops->getOpsVar("indexReprocess") == 1) {

	    	// Instantiate new database object
		    $idsDB = new idsDB();

		    // Queries for clearing index tables
	    	$idsQueryA = $idsDB->query("truncate table idsReverseIndex");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexText");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexSport");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexDport");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexSip");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexDip");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexWin");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexTtl");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexLen");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexProto");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexTime");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexAck");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexSeq");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexSensor");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexCategory");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexSignature");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexLevel");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexModule");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexSignatureName");
	        $idsQueryA = $idsDB->query("truncate table idsReverseIndexCategoryName");
	        
	        // Close database handle
	        $idsDB->close();
	
	        // Update status to reflect indexing has been cleared
	        $objStatus->setStatusVar("processor_lastIndex", 0);
		    $objStatus->saveStatus();
		    
		    // Update ops variable to reset manual reprocessing variable
	        $ops->setOpsVar("indexReprocess", 0);
	    }		
	}
	
	function writeWordIndex($id, $array) {
		
		// Instantiate new database object
	    $idsDB = new idsDB();

		// Loop through text array and write indexes
	    for ($i=0;$i<count($array);$i++) {
	    
	    	// Change string to lower-case
	    	$text = strtolower($array[$i]);
	    	
	    	if ($text == "of" || $text == "and" || $text == "the" || $text == "to" || $text == "how" || $text == "or") {
	    	
	    		// do nothing
	    		
	    	} else {
			    // Insert text data
		        $idsQueryA = $idsDB->query("insert into idsReverseIndexText (text) values ('$text')", 0);
	
		        // Get last insert id
		        $idsQueryA = $idsDB->query("select id from idsReverseIndexText where text = '$text'");
	    		while (list($t_id) = mysql_fetch_row($idsQueryA)) {
	    			$textid = $t_id;
	    		}
		        
		        // Insert text id into index
		        $idsQueryA = $idsDB->query("insert into idsReverseIndex (loc, id, rel) values ('$id', '$textid', '$rel')");
	    	}
	    }
        
	    // Close database handle
	    $idsDB->close();
	}
	
	function writeAdvancedIndex($id, $ip_len, $hdr_win, $ip_ttl, $hdr_seq, $hdr_ack) {
		
		$this->writeData("idsReverseIndexLen", $id, $ip_len);
		$this->writeData("idsReverseIndexWin", $id, $hdr_win);
		$this->writeData("idsReverseIndexTtl", $id, $ip_ttl);
		$this->writeData("idsReverseIndexSeq", $id, $hdr_seq);
		$this->writeData("idsReverseIndexAck", $id, $hdr_ack);
	}
	
	function writeStandardIndex($id, $sip, $dip, $sport, $dport, $epoch, $proto, $sensorid, $etypeid, $enameid, $level, $module, $ename, $etypename) {
		
		$this->writeData("idsReverseIndexSip", $id, $sip);
		$this->writeData("idsReverseIndexDip", $id, $dip);
		$this->writeData("idsReverseIndexSport", $id, $sport);
		$this->writeData("idsReverseIndexDport", $id, $dport);
		$this->writeData("idsReverseIndexTime", $id, $epoch);
		$this->writeData("idsReverseIndexProto", $id, $proto);
		$this->writeData("idsReverseIndexSensor", $id, $sensorid);
		$this->writeData("idsReverseIndexCategory", $id, $etypeid);
		$this->writeData("idsReverseIndexSignature", $id, $enameid);
		$this->writeData("idsReverseIndexLevel", $id, $level);
		$this->writeData("idsReverseIndexModule", $id, $module);
		$this->writeDataHybrid("idsReverseIndexSignatureName", $id, $ename, $enameid);
		$this->writeDataHybrid("idsReverseIndexCategoryName", $id, $etypename, $etypeid);
	}
	
	function writeData($table, $id, $array) {
		
		// Instantiate new database object
	    $idsDB = new idsDB();		
	    
	    // Insert indexes
	    for ($i=0;$i<count($array);$i++) {
			$mqi .= " ('$id[$i]', '$array[$i]'),";
	    }
	    // Strip comma from end if exist
		if (substr($mqi, -1, 1) == ",") $mqi = substr($mqi, 0, -1);
	    
        $idsQueryA = $idsDB->query("INSERT INTO $table (loc, data) VALUES $mqi");
		
	    // Close database handle
	    $idsDB->close();
	}

	function writeDataHybrid($table, $id, $array1, $array2) {
		
		// Instantiate new database object
	    $idsDB = new idsDB();		
	    
	    // Insert indexes
	    for ($i=0;$i<count($array1);$i++) {
			$mqi .= " ('$id[$i]', '$array1[$i]', '$array2[$i]'),";
	    }
	    // Strip comma from end if exist
		if (substr($mqi, -1, 1) == ",") $mqi = substr($mqi, 0, -1);
	    
        $idsQueryA = $idsDB->query("INSERT INTO $table (loc, data, id) VALUES $mqi");
		
	    // Close database handle
	    $idsDB->close();
	}
	
	function sanitizeIndexes() {
		
		$sanRunA = 1500;
		$sanRunB = 250;
		$sanRunC = 25;
		
		// Instantiate new database object
	    $idsDB = new idsDB();		

	    // Random num to choose which sanitizer we run
	    $ran = rand(1,3);
	    
	    if ($ran == 1) {
	    	
			procWrite("C", ".. Sanitizing index-a Started");
	    	
			// Check counts to see if sanitizing is necessary
			$idsQueryA = $idsDB->query("select count(id) from idsMain");
			while (list($t_id) = mysql_fetch_row($idsQueryA)) {
				$totalEvents = $t_id;
			}
			$idsQueryA = $idsDB->query("select count(loc) from idsReverseIndexTime");
			while (list($t_id) = mysql_fetch_row($idsQueryA)) {
				$totalIndex = $t_id;
			}
			if ($totalEvents == $totalIndex) return;
		    
	        // Get random array of locations
	        $idsQueryA = $idsDB->query("select loc from idsReverseIndexTime order by rand() limit $sanRunA");
			while (list($t_loc) = mysql_fetch_row($idsQueryA)) {
				$locArray[] = $t_loc;
			}
	
			// Implode into query compatible string
			$compString = implode(",", $locArray);
			
			// Query to compare ID's
			$idsQueryA = $idsDB->query("select id from idsMain where id in ($compString)");
			while (list($t_id) = mysql_fetch_row($idsQueryA)) {
				$existArray[] = $t_id;
			}
			
			// Compute difference of arrays for removal	
			$remArray = array_diff($locArray, $existArray);
			
			// If remove array exists, we do what we are suppose to
			if ($remArray) {
				$cnt = count($remArray);
			
				// Delete events from index
				deleteEventsByArray($remArray);
				
			}
			
			if (!$cnt) $cnt = 0;
			procWrite("C", " . Sanitized $cnt index-a records");
			
	    } else if ($ran == 2) {
	    	
			procWrite("C", ".. Sanitizing index-b Started");
	    	
	        $idsQueryA = $idsDB->query("select id, text from idsReverseIndexText order by rand() limit $sanRunB");
			while (list($t_id, $t_text) = mysql_fetch_row($idsQueryA)) {
				
				if (
					strstr($t_text, "mmm") || 
					strstr($t_text, "asdf") || 
					strstr($t_text, "fbq") || 
					strstr($t_text, "xxxx") || 
					strstr($t_text, "yyyy") || 
					strstr($t_text, "cccc") || 
					strstr($t_text, "fzz") || 
					strstr($t_text, "vzz") || 
					strstr($t_text, "szz") || 
					strstr($t_text, "xnm") || 
					strstr($t_text, "mzn") || 
					strstr($t_text, "nmz") || 
					strstr($t_text, "mzw") || 
					strstr($t_text, "mnv") || 
					strstr($t_text, "xmz") || 
					strstr($t_text, "nzq") || 
					strstr($t_text, "xzy") || 
					strstr($t_text, "hvi") || 
					strstr($t_text, "jmv") || 
					strstr($t_text, "zwx") || 
					strstr($t_text, "jcq")) {

					$cnt++;
					
			        $idsQueryB = $idsDB->query("delete from idsReverseIndexText where id = $t_id");
			        $idsQueryB = $idsDB->query("delete from idsReverseIndex where id = $t_id");
					
				}
				
			}
			
			if (!$cnt) $cnt = 0;
			procWrite("C", " . Sanitized $cnt index-b records");
	    	
	    } else if ($ran == 3) {

			procWrite("C", ".. Sanitizing index-c Started");
	    	
	        $idsQueryA = $idsDB->query("select id, text from idsReverseIndexText order by rand() limit $sanRunC");
			while (list($t_id, $t_text) = mysql_fetch_row($idsQueryA)) {

		        $idsQueryB = $idsDB->query("select count(loc) as cnt, loc from idsReverseIndex where id = $t_id group by loc");
				while (list($t_cnt, $t_loc) = mysql_fetch_row($idsQueryB)) {
				
					if ($t_cnt > 1) {
						
						$lim = $t_cnt - 1;
						$idsQueryC = $idsDB->query("delete from idsReverseIndex where loc = $t_loc and id = $t_id limit $lim");
						
						$cnt = $cnt + $lim;
						unset($lim);
					}
					
				}
			}
			
			if (!$cnt) $cnt = 0;
			procWrite("C", " . Sanitized $cnt index-c records");
	    	
	    }
	    
	    // Close database handle
	    $idsDB->close();
		
	}
}

?>