<?

class processor {
	
	// Returns complete list of available spion sensor data files from /spion/$sensorid directory
	function getSpionFiles($sensorid) {
		global $ops, $root_path;
		
		// Instantiate new sensor object
	    $objSensor = new mySensor();
		
    	// Load specific sensor from module
    	$objSensor->loadSensor($sensorid);
		
    	// Set variables
		$sid = $objSensor->getSensorVar("sid");    	

		// Set path
		$spionPath = "spion/store/$sid.store";
    	
		// Check to ensure ops variable is not empty
		if ($spionPath != "") {
			
			// Open spion directory and check for error
			if (!$this_dir = @dir("$root_path$spionPath/")) {
			    procWrite("A", " ! Path Error: $root_path/$spionPath could not be opened. Please ensure all Spion directories exist and are read/writable by this processor.");
			} else {
				
				// Read directory
			    while ($dir = $this_dir->read()) {
			    	
			    	// Loop through files
			        while ($file = $this_dir->read()) {
			        	// Only check files which are NOT . and ..
			        	
				        if ($file != "." && $file != "..") {
			    	        if (substr($file, -4, 4) == ".dat") {
			                    $filesArray[] = $file;
			                }
			            }
			        }
			    }
			}
			
		}
		// Return array of files found in /spion/$sensorid directory
		return $filesArray;		
	}	
	
	// Primary spion sensor processor logic
	function processSpionSensor($sensorid) {
		global $ops, $root_path;

		// Instantiate new sensor object
	    $objSensor = new mySensor();

    	// Load specific sensor from module
    	$objSensor->loadSensor($sensorid);
        	
    	// Set variables
		$sensorSID = $objSensor->getSensorVar("sid");      	
    	$sensorID = $objSensor->getSensorVar("id");
    	$sensorName = $objSensor->getSensorVar("name");

    	// Import sensor data into spion database
    	$cnt = $this->importSpionData($sensorID, $sensorSID);
    	
    	return $cnt;
	}	
	
	// Specifically imports spion data from spion.store to aanval database
	function importSpionData($sensorID, $sensorSID) {
		global $ops, $root_path;
		
	    // Retrieve List of spion sensor files from /spion/store/$id[$i] directory
	    $spionFiles = $this->getSpionFiles($sensorID);
		
		// Loads syslog module
        $moduleDB = new moduleDB;
        $moduleDB->loadDB(2);
        
        $cnt = 0;
        
        for ($i=0;$i<count($spionFiles);$i++) {
        
	        // Rename .dat file to .processing to separate incoming data from those already in processing
			if (file_exists("$root_path/spion/store/$sensorSID.store/$spionFiles[$i]")) {
				if (!@rename("$root_path/spion/store/$sensorSID.store/$spionFiles[$i]", "$root_path/spion/store/$sensorSID.store/$spionFiles[$i].processing")) {
	    			procWrite("A", " ! File Error: [$root_path/spion/store/$sensorSID.store/$spionFiles[$i]] Could not be renamed successfuly - possible permissions problem on /spion/store/ directory");
				} else {

				}
			}

			// Check to ensure that renaming of the file was successful - if exists we continue to import
            if (file_exists("$root_path/spion/store/$sensorSID.store/$spionFiles[$i].processing")) {

            	// Open file for reading
				if ($data = @file("$root_path/spion/store/$sensorSID.store/$spionFiles[$i].processing")) {

					foreach ($data as $line) {
					
						if ($this->regexParse($line, "((?<=EPOCH\:).+)")) {
							$timestamp = $this->regexParse($line, "((?<=EPOCH\:).+)");
						}

						if ($this->regexParse($line, "((?<=SIP\:).+)")) {
							$sip = ip_to_acid($this->regexParse($line, "((?<=SIP\:).+)"));
						}

						if ($this->regexParse($line, "((?<=SPORT\:).+)")) {
							$sport = $this->regexParse($line, "((?<=SPORT\:).+)");
						}

						if ($this->regexParse($line, "((?<=DIP\:).+)")) {
							$dip = ip_to_acid($this->regexParse($line, "((?<=DIP\:).+)"));
						}						
						
						if ($this->regexParse($line, "((?<=DPORT\:).+)")) {
							$dport = $this->regexParse($line, "((?<=DPORT\:).+)");
						}					
						
						if ($this->regexParse($line, "((?<=BID\:).+)")) {
							$etypeid = $this->regexParse($line, "((?<=BID\:).+)");
						}			
						
						if ($this->regexParse($line, "((?<=BNAME\:).+)")) {
							$etypename = $this->regexParse($line, "((?<=BNAME\:).+)");
						}			
									
						if ($this->regexParse($line, "((?<=SID\:).+)")) {
							$enameid = $this->regexParse($line, "((?<=SID\:).+)");
						}			
						
						if ($this->regexParse($line, "((?<=SNAME\:).+)")) {
							$ename = $this->regexParse($line, "((?<=SNAME\:).+)");
						}			
							
					}
					
	            	// Open file for reading
					if ($pldFile = @file("$root_path/spion/store/$sensorSID.store/$spionFiles[$i].pld")) {
						$payload = "";
						foreach ($pldFile as $line) {
							$payload .= $line;
						}
					}
					
					// Combine the date and time into $intime for database update
					$intime = date("U");

					// Insert filter results into idsMain
                    $idsDB = new idsDB;
                    $idsQueryA = $idsDB->query("insert into idsMain (
                        enameid,
                        etypeid,
                        sensorid,
                        sid,
                        module,
                        epoch,
                        timestamp,
                        sip,
                        dip,
                        sport,
                        dport,
                        proto,
                        level,
                        ename,
                        etypename,
                        payload,
                        enabled
                            ) values (
                        '$enameid',
                        '$etypeid',
                        '$sensorID',
                        '$sensorSID',
                        '3',
                        '$intime',
                        '$timestamp',
                        '$sip',
                        '$dip',
                        '$sport',
                        '$dport',
                        '$protocol',
                        '$level',
                        '$ename',
                        '$etypename',
                        '$payload',
                        '1'
                    )");
                    $idsDB->close();				
                    
                    $flashWriteCount++;
					
				} else {
						
					// Could not open file
        			procWrite("A", " ! File Error: [ $root_path/spion/store/$sensorSID.store/$spionFiles[$i].processing ] Could not be opened - possible permissions problem on /spion/store/ directory");
				}

				// Delete .processing file
				if (!@unlink("$root_path/spion/store/$sensorSID.store/$spionFiles[$i].processing")) {
					procWrite("A", " ! File Error: [ $root_path/spion/store/$sensorSID.store/$spionFiles[$i].processing ] Could not be removed - possible permissions problem on /spion/store/ directory");
				}  				
				// Delete .dat.pld file
				if (!@unlink("$root_path/spion/store/$sensorSID.store/$spionFiles[$i].pld")) {
					procWrite("A", " ! File Error: [ $root_path/spion/store/$sensorSID.store/$spionFiles[$i].pld ] Could not be removed - possible permissions problem on /spion/store/ directory");
				}  				
				
            }
		
            $cnt++;
            
        }
            	
		// Close database connection for spion module
		$moduleDB->close();	
		
		return $cnt;	
		
	}	
	
	// Returns complete list of available syslog sensor data files from /syslog/ directory
	function getSyslogFiles() {
		global $ops, $root_path;
		
		$syslogPath = $ops->getOpsVar("site_dir_syslog");
		
		// Check to ensure ops variable is not empty
		if ($syslogPath != "") {
	
			// Open syslog directory and check for error
			if (!$this_dir = @dir("$root_path/$syslogPath")) {
			    procWrite("A", " ! Path Error: $root_path/$syslogPath could not be opened. Please check your  /conf/conf.php settings to resolve this issue.");
			} else {
				
				// Read directory
			    while ($dir = $this_dir->read()) {
			    	
			    	// Loop through files
			        while ($file = $this_dir->read()) {
			        	// Only check files which are NOT . and ..
			        	
				        if ($file != "." && $file != "..") {
			    	        if (substr($file, -7, 7) == ".syslog") {
			                    procWrite("A", " . Syslog File: $file Available");
			                    $filesArray[] = $file;
			                }
			            }
			        }
			    }
			}
			
		}
		// Return array of files found in /syslog/ directory
		return $filesArray;		
	}
	
	// Identifies if new syslog sensor files exist, and writes newly found sensors to syslog module database (checks getSyslogFiles() against syslog module sensor database)
	function newSyslogSensorCheck($syslogFiles) {
		global $ops, $root_path;
		
		// Loads syslog module
	    $objModule = new myModule();
	    $objModule->loadModule("2");
	
		// Loops through $sensorFiles and checks syslog module database for existing sensors
		for ($i=0;$i<count($syslogFiles);$i++) {
			
			// Retrieves 2 forms of IP address (dotted and numeric)
			$sourceIPa = str_replace("indata_", "", (str_replace(".syslog", "", $syslogFiles[$i])));
	        $sourceIP = ip_to_acid($sourceIPa);
	
	        // Check to see if sensor exists, and sets $sensorFound=1 if found
        	$moduleDB = new moduleDB;
        	$moduleDB->loadDB(2);
        	$moduleQuery = $moduleDB->query("select id from sensors where source = '$sourceIP'");
	        while (list($d_sid) = mysql_fetch_row($moduleQuery)) {
	        	$sid = $d_sid;
	            $sensorFound = 1;
	        }
	        
	        // If $sensorFound != 1 then we write new sensor to syslog module sensor table
	        if (!$sensorFound) {
	            $moduleQuery = $moduleDB->query("insert into sensors (source) values ('$sourceIP')");
				procWrite("A", " . New Syslog Sensor Found ($sourceIPa)");
			}
			// Reset $sensorFound variable and close mysql connection
			unset($sensorFound);
	        $moduleDB->close();
		}		
	}

	// Primary syslog sensor processor logic
	function processSyslogSensors() {
		global $ops, $root_path;

		// Instantiate new sensor object
	    $objSensor = new mySensor();

	    // Retrieve list of current sensor id's from syslog module
	    $sensorArray = $objSensor->getSensorIDs(2);

	    // Loop through listed sensors
    	for ($i=0;$i<count($sensorArray);$i++) {
       	
        	// Load specific sensor from module
        	$objSensor->loadSensor($sensorArray[$i]);
        	
        	// Define variable(s) from module
        	$sensorSID = $objSensor->getSensorVar("sid");
        	$sensorID = $objSensor->getSensorVar("id");
        	$sensorName = $objSensor->getSensorVar("name");

        	procWrite("A", " . Processing Syslog Sensor: $sensorName");
        	
        	// Import sensor data into syslog database
        	$this->importSyslogData($sensorID, $sensorSID);
    	}
	}
	
	// Specifically imports syslog data from /syslog/indata_$sensorIP.syslog to syslog database
	function importSyslogData($sensorID, $sensorSID) {
		global $ops, $root_path, $flashWriteCount;

		$processCount = 0;
		
		// Loads syslog module
        $moduleDB = new moduleDB;
        $moduleDB->loadDB(2);
        
		// Query syslog database for sensor filters and source information
        $moduleQuery = $moduleDB->query("select
        	f_sample,
            source,
            f_date,
            f_time,
            f_sip,
            f_dip,
            f_sport,
            f_dport,
            f_protocol,
            f_level,
            f_ename,
            f_etypename,
            f_payload
		from sensors where id = $sensorSID");
		while (list($f_sample, $source, $f_date, $f_time, $f_sip, $f_dip, $f_sport, $f_dport, $f_protocol, $f_level, $f_ename, $f_etypename, $f_payload) = mysql_fetch_row($moduleQuery)) {
            $sensorSource = acid_to_ip($source);
	        $f_date = base64_decode($f_date);
	        $f_time = base64_decode($f_time);
            $f_sip = base64_decode($f_sip);
            $f_dip = base64_decode($f_dip);
            $f_sport = base64_decode($f_sport);
            $f_dport = base64_decode($f_dport);
            $f_protocol = base64_decode($f_protocol);
            $f_level = base64_decode($f_level);
			$f_ename = base64_decode($f_ename);
            $f_etypename = base64_decode($f_etypename);
            $f_payload = base64_decode($f_payload);
           
            // Rename .syslog file to .processing to separate incoming data from those already in processing
			if (file_exists("$root_path/syslog/indata_$sensorSource.syslog")) {
				if (!rename("$root_path/syslog/indata_$sensorSource.syslog", "/$root_path/syslog/indata_$sensorSource.processing")) {
        			procWrite("A", " ! File Error: [$root_path/syslog/indata_$sensorSource.syslog] Could not be renamed successfuly - possible permissions problem on /syslog/ directory");
				} else {
        			procWrite("A", " . indata_$sensorSource.syslog renamed successfully");
				}
			}

			// Check to ensure that renaming of the file was successful - if exists we continue to import
            if (file_exists("$root_path/syslog/indata_$sensorSource.processing")) {
            	
            	// Open file for reading
				if ($handle = @fopen("/$root_path/syslog/indata_$sensorSource.processing", "r")) {

					// Report import status
        			procWrite("A", " . Importing indata_$sensorSource.processing");
					
					// Loop through each line of the .processing syslog data file
					while (!feof($handle)) {
                        $timestamp = date("U");
						$buffer = fgets($handle, 4096);

						// Check to ensure the buffer (line) is not empty and continue
						if ($buffer != "") {
							
							// Replace TAB with a single space character
							$buffer = str_replace("\t", " ", $buffer);
							
							// Time Filter
							$time = $this->regexParse($buffer, $f_time);
							if (!$time || $time == "") $time = date("H:i:s");

                            // Date Filter 
                            $date = $this->regexParse($buffer, $f_date);
							if (!$date || $date == "") $date = date("j F Y");

                            // Source IP Filter
                            $sip = $this->regexParse($buffer, $f_sip);
                            if (!$sip || $sip == "") {
                            	$sip = $sensorSource;
                            	$sip = ip_to_acid($sip);
                           	} else {
                            	$sip = ip_to_acid($sip);
	                        }
                            
                            // Destination IP Filter
                            $dip = $this->regexParse($buffer, $f_dip);
                            if (!$dip || $dip == "") {
                            	$dip = $sensorSource;
                            	$dip = ip_to_acid($dip);
                           	} else {
                            	$dip = ip_to_acid($dip);
	                        }

                            // Source Port Filter
							$sport = $this->regexParse($buffer, $f_sport);

                            // Destination Port Filter
							$dport = $this->regexParse($buffer, $f_dport);

                            // Protocol Filter
							$protocol = $this->regexParse($buffer, $f_protocol);
                            $protocol = nameToProto($protocol);

                            // Level Filter
							$level = $this->regexParse($buffer, $f_level);
                            if ($level == "") $level = 5;

                            // Event Name (signature) Filter
							$ename = $this->regexParse($buffer, $f_ename);
                            $moduleQueryInternal = $moduleDB->query("insert into signature (signature) values ('$ename')");
                            $moduleQueryInternal = $moduleDB->query("select id from signature where signature = '$ename'");
                            while (list($sigid) = mysql_fetch_row($moduleQueryInternal)) {
                                $sig_id = $sigid;
                            }

                            // Event Category Filter
							$etypename = $this->regexParse($buffer, $f_etypename);
                            if ($etypename == "") $etypename = "General Syslog";
                            $moduleQueryInternal = $moduleDB->query("insert into category (category) values ('$etypename')");
                            $moduleQueryInternal = $moduleDB->query("select id from category where category = '$etypename'");
                            while (list($typeid) = mysql_fetch_row($moduleQueryInternal)) {
                                $type_id = $typeid;
                            }

                            // Payload Filter
							$payload = $this->regexParse($buffer, $f_payload);

                            // If Date filter does not contain the year - alter the results to contain the year
							if (!strstr($date, date("Y"))) $date = $date . " " . date("Y");

							// Combine the date and time into $intime for database update
							$intime = strtotime("$date $time");

							// Insert filter results into idsMain
	                        $idsDB = new idsDB;
	                        $idsQueryA = $idsDB->query("insert into idsMain (
                                enameid,
                                etypeid,
                                sensorid,
                                sid,
                                module,
                                epoch,
                                timestamp,
                                sip,
                                dip,
                                sport,
                                dport,
                                proto,
                                level,
                                ename,
                                etypename,
                                payload,
                                enabled
                                    ) values (
                                '$sig_id',
                                '$type_id',
                                '$sensorID',
                                '$sensorSID',
                                '2',
                                '$intime',
                                '$timestamp',
                                '$sip',
                                '$dip',
                                '$sport',
                                '$dport',
                                '$protocol',
                                '$level',
                                '$ename',
                                '$etypename',
                                '$payload',
                                '1'
                            )");
	                        $idsDB->close();
	                        
	                        $flashWriteCount++;

#							// Check to see if sample data field is empty, and populate if necessary
#							if ($f_sample == "") {
	                            $moduleQueryA = $moduleDB->query("update sensors set f_sample = '$buffer' where id = $sensorSID");
#							}
						}
					}
					
					// Close file handle
					fclose($handle);

				} else {
						
					// Could not open file
        			procWrite("A", " ! File Error: [$root_path/syslog/indata_$sensorSource.processing] Could not be opened - possible permissions problem on /syslog/ directory");
				}
				
				// Delete .processing file
				if (!unlink("$root_path/syslog/indata_$sensorSource.processing")) {
        			procWrite("A", " ! File Error: [$root_path/syslog/indata_$sensorSource.processing] Could not be removed - possible permissions problem on /syslog/ directory");
				} else {
        			procWrite("A", " . indata_$sensorSource.processing removed successfully");
				}
			}
		}
		
		// Close database connection for syslog module
		$moduleDB->close();
		
	}

	function regexParse($buffer, $regex) {
	
		/* Parse buffer with provided regular expression and return matched results */
		
		// Check for multiple expression separator
		if (strstr($regex, "~~")) {
		
			// Create array based upon separator
			$regex = explode("~~", $regex);
			
			// Set $result variable to equal buffer for loop below
			$result = $buffer;
			
			// Loop through regex array
			for ($z=0;$z<count($regex);$z++) {
				
				// Match regex against $result and store in $match
		    	preg_match("/$regex[$z]/", $result, $match);
		    	
		    	// Clean results
		    	$result = trim(rtrim($match[0]));
		    	
		    	// Unset $match variable
				unset($match);                            			
			}
			
			// Set $out variable
			$out = $result;
			
			// Unset $result variable
			unset($result);
				
		} else {
			
			// Single regular expression match
			
			// Match regex against $buffer and store in $match
		    preg_match("/$regex/", $buffer, $match);
		    
		    // Clean results
		    $out = trim(rtrim($match[0]));
		    
		    // Unset $match variable
			unset($match);
		}	
	
		// Return results
		return $out;
	}

	
	
}

?>